import org.garret.serme.*;


public class RecordComparator extends AbstractComparator { 
    public int compareMembers(Object m1, Object m2) { 
        Record r1 = (Record)m1;
        Record r2 = (Record)m2;
        return r1.key < r2.key ? -1 : r1.key == r2.key ? 0 : 1;
    }

    public int compareMemberWithKey(Object mbr, Object key) { 
        Record rec = (Record)mbr;
        long lkey = ((Long)key).longValue();
        return rec.key < lkey ? -1 : rec.key == lkey ? 0 : 1;
    }    
}

    