package org.garret.serme.impl;

import java.util.*;

class KeyEnumeration implements Enumeration { 
    KeyEnumeration(HashEntry[] table) {             
        this.table = table;
        for (int i = 0; i < table.length; i++) { 
            if (table[i] != null) {
                e = table[i];
                currIndex = i;
                return;
            }
        }
    }
    
    public boolean hasMoreElements() { 
        return e != null;
    }
    
    public Object nextElement() { 
        if (e == null) { 
            throw new NoSuchElementException();
        }
        Object key = e.obj;            
        if ((e = e.next) == null) { 
            HashEntry[] tab = table;
            for (int i = currIndex+1; i < tab.length; i++) { 
                if (tab[i] != null) { 
                    currIndex = i;
                    e = tab[i];
                    break;
                }
            }
        }
        return key;
    }
    
    int         currIndex;
    HashEntry[] table;
    HashEntry   e;
}

            
