package org.garret.serme;

/**
 * Abstract comparator. This class should be used as base class by comparator 
 * which has not state (no persistent fields)
 */
public abstract class AbstractComparator implements IComparator { 
    public void readObject(IInputStream in) {} 
    public void writeObject(IOutputStream in) {} 
}

