package org.garret.serme.impl;

public class ByteBuffer {
    protected void extend(int size) {  
        int newUsed = used + size;
        if (newUsed > arr.length) { 
            int newLen = newUsed > arr.length*2 ? newUsed : arr.length*2;
            byte[] newArr = new byte[newLen];
            System.arraycopy(arr, 0, newArr, 0, used); 
            arr = newArr;
        }
    }
    
    public byte[] toByteArray() { 
        byte[] result = new byte[used];
        System.arraycopy(arr, 0, result, 0, used); 
        return result;
    }

    ByteBuffer() { 
        arr = new byte[64];
    }    

    protected byte[] arr;
    protected int    used;
}




